list    c=150,n=0,f=inhx8m,p=16F84a,r=dec,x=on,fixed
	__config  3FF1h
	include P16F84A.INC

; Takt = 4MHz 
;*******************************************************************
; PWM kontrol_2_4_1 by Petr Nosek 2010
;*******************************************************************
;                definice konstant
#define		bank0   bcf  STATUS,RP0                      ;prepnuti do banky 0 v pameti dat
#define		bank1   bsf  STATUS,RP0                      ;prepnuti do banky 1 v pameti dat
;*******************************************************************
;           definice portu
#define		ovlRA0  PORTA,0                                  ;Spnan programu pinem RA0 (pulz ?ms)           
;*******************************************************************
;                definice uivatelskch registr
OffRam		EQU	20h			;Prvn adresa pamti RAM pro PIC16F873 - 368 bajt (20h - 7Fh)
TMP0		EQU	OffRam+1	;Nactn casovch smycek
TMP1		EQU	OffRam+2	;Nactn casovch smycek
TMP2		EQU	OffRam+3	;Nactn casovch smycek
IMPwidth	EQU	OffRam+4	;Naten ka ovldacho impulzu
Imp50m		EQU	OffRam+5	;Promnn pro smyku analiz
;******************************************************************************************
org       2100h                                                  ;pednast. adr. v EEPROM
;**************************************************************************
; podepsn SW,Created by Petr Nosek 2010 
de 67,114,101,97,116,101,100,32,98,121,32,80,101,116,114,32,78,111,115,101,107,32,32,32,50,48,49,48,32,32,174,32    
;*************************************************************************
	org 0h		;zatek programu

Ini
	bank1					;pepnut do bank 1 v pameti dat
	movlw	255
	movwf	TRISA			;A0-7 jako vstup
	clrf	TRISB			;B0-7 jako vstup
	bcf 	INTCON,GIE		;zakazat vsechna preruseni
	bank0					;pepnut do bank 0 v pameti dat                        
	clrw					;vynulovn pracovnho registru
	clrf	PORTA			;vynulovn portu A
	clrf	PORTB			;vynulovn portu B
;-------------------------------------------------------------------------------------------------
Start    
	call	Cek40m
	movlw	b'00000000'
	movwf	PORTB

;--------Test vstupu----------
tstin                             
	movlw	50
	movwf	Imp50m
	clrf	IMPwidth
	btfsc	ovlRA0			;Test konce periody ped sputnm natn pulzu periody nov
	goto	tstin
	btfss	ovlRA0			;Test zatku  pulzu PWM nov periody
	goto	tstin
analiz  
	btfss	ovlRA0			;Sputn kontroly  pulzu PWM a naten jeho ky
							; 0,5m -sekundovm vzorkovnm do promnn IMPwidth
	goto	kmpr1
	incf	IMPwidth
	call	Cek0.5m
	decfsz	Imp50m			;Odtn 25ms z ky jedn peroidy
	goto	analiz

;--------komparace pulzu----------               
;IMPwidth 1 = 0,5ms
kmpr1
	movfw	IMPwidth		;Test zda IMPwidth (ka pulzu) je/nen 2ms )
	xorlw	4				;Jestli, e IMPwidth je 4 vsledek XOR =0 potom Z =1
	btfss	STATUS,Z
	goto	kmpr2			;IMPwidth nen 4
	call	mlhovky
	goto	tstin
kmpr2
	movfw	IMPwidth		;Test zda IMPwidth (ka pulzu) je/nen 1,5ms)
	xorlw	3				;Jestli, e IMPwidth je 3 vsledek XOR =0 potom Z =1
	btfss	STATUS,Z
	goto	kmpr3			;IMPwidth nen 3
	call	S_ML
	goto	tstin
kmpr3
	movfw	IMPwidth		;Test zda IMPwidth (ka pulzu) je/nen 1ms) 
	xorlw	2				; Jestli, e IMPwidth je 2 vsledek XOR =0 potom Z =1
	btfss	STATUS,Z
	goto	Start			;IMPwidth nen 2
	call	strobo
	goto	tstin

;--------Ovldn vstup----------                
mlhovky                      
	movlw	b'01000000'
	movwf	PORTB
	return

strobo
	movlw	b'00100011'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'00100000'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw               b'00100011'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'00100000'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'00011100'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'00010000'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'00011100'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'00010000'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'00111100'
	movwf	PORTB
	return

S_ML               
	movlw	b'01100011'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'01100000'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'01100011'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'01100000'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'01011100'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'01010000'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'01011100'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'01010000'
	movwf	PORTB
	call	Cek40m
	call	Cek15m
	movlw	b'01111100'
	movwf	PORTB
	return

;------------------------------------------------------------------------------------------------
;                                              PODPROGRAMY
;------------------------------------------------------------------------------------------------ 

;-------- cas = 39,2 ms ----------     
Cek40m
	movlw	51
	movwf	TMP0
	movlw	255
	movwf	TMP1
	goto	Smycka

;-------- cas = 14,9 ms ----------     
Cek15m           
	movlw	33
	movwf	TMP0
	movlw	145
	movwf	TMP1
	goto	Smycka

;-------- cas = 0,49 ms ----------     
Cek0.5m
	movlw	3
	movwf	TMP0
	movlw	37
	movwf	TMP1
	goto	Smycka

;-------------------------------

Smycka           
	movf	TMP0,W
	movwf	TMP2

;       ------------------------
Smycka1
	decfsz	TMP2,F			; mala smycka
	goto	Smycka1

;       ------------------------
	decfsz	TMP1,F			; velka smycka
	goto	Smycka

;       ------------------------
	return

;--------------------------------------------------------------------------------------------             
	end

 
